package ru.ulstu.configuration;

import org.eclipse.jetty.server.ServerConnector;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.web.embedded.jetty.JettyServerCustomizer;
import org.springframework.boot.web.embedded.jetty.JettyServletWebServerFactory;
import org.springframework.boot.web.server.ConfigurableWebServerFactory;
import org.springframework.boot.web.server.WebServerFactoryCustomizer;
import org.springframework.context.annotation.Configuration;

@Configuration
public class HttpListenerConfiguration implements WebServerFactoryCustomizer<ConfigurableWebServerFactory> {
    @Value("${server.http.port}")
    private int httpPort;

    private void configureJetty(JettyServletWebServerFactory jettyFactory) {
        jettyFactory.addServerCustomizers((JettyServerCustomizer) server -> {
            ServerConnector serverConnector = new ServerConnector(server);
            serverConnector.setPort(httpPort);
            server.addConnector(serverConnector);
        });
    }

    @Override
    public void customize(ConfigurableWebServerFactory factory) {
        if (factory instanceof JettyServletWebServerFactory) {
            configureJetty((JettyServletWebServerFactory) factory);
        }
    }
}
